<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
    <xsl:output method="xml" indent="yes"/>
    <xsl:strip-space elements="config"/>
    <xsl:preserve-space elements="parameters"/>
    <xsl:template match="/">
        <!--<xsl:call-template name="volist"/>-->
        <xsl:for-each select="/*">
            <xsl:copy>
                <!--<xsl:call-template name="volist"/>-->
                <xsl:apply-templates/>
            </xsl:copy>
        </xsl:for-each>
    </xsl:template>
<!--    <xsl:template name="volist">
        <xsl:copy-of select="volist"/>
    </xsl:template>-->
    <xsl:template match="volist">
        <xsl:copy-of select="."/>
    </xsl:template>
    <xsl:template match="*[not (name() = 'node') and not(@iterate) and not(name() = 'volist')]">
        <xsl:copy-of select="."/>
    </xsl:template>
    <xsl:template match="node">
        <xsl:copy>
            <xsl:copy-of select="@*"/>
            <!--<xsl:call-template name="volist"/>-->
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>
    <xsl:template match="instance[@iterate]">
        <xsl:variable name="containerName" select="@iterate"/>
        <xsl:choose>
            <xsl:when test="count(../*[name() = $containerName]) > 0">
                <xsl:call-template name="container_tpl"> 
                    <xsl:with-param name="container" select="../*[name() = $containerName]"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:call-template name="container_tpl"> 
                    <xsl:with-param name="container" select="/*/*[name() = $containerName]"/>
                </xsl:call-template>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="container_tpl">
        <xsl:param name="container"/>
        <xsl:variable name="excludes" select="exclude"/>
        <xsl:variable name="instanceParams" select="parameters/*"/>
        <xsl:variable name="instanceAttrs" select="@*[not(name()='name') and
            not(name()='iterate')]"/>
        <xsl:variable name="includes" select="include"/>
        <xsl:for-each select="$container">
            <xsl:if test="count($excludes[@name=current()/@name])=0 and
                (count($includes)=0 or count($includes[@name=current()/@name])=1)">
                <xsl:element name="instance">
                    <xsl:copy-of select="$instanceAttrs"/>
                    <xsl:attribute name="name">
                        <xsl:value-of select="@name"/>
                    </xsl:attribute>
                    <parameters>
                        <xsl:copy-of select="./parameters/*"/>
                        <xsl:copy-of select="$instanceParams"/>
                    </parameters>
                </xsl:element>
            </xsl:if>
        </xsl:for-each>
    </xsl:template>
</xsl:stylesheet>
