<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
    <xsl:output method="xml" indent="yes"/>
    <xsl:strip-space elements="config"/>
    <xsl:preserve-space elements="parameters"/>
    <xsl:template match="/">
        <xsl:for-each select="/*">
            <xsl:copy>
                <xsl:copy-of select="@*"/>
                <xsl:call-template name="volist"/>
                <xsl:copy-of select="/*/*[not(name()='node') and not(name()='volist')]"/>
                <xsl:call-template name="node"/>
            </xsl:copy>
        </xsl:for-each>
    </xsl:template>
    
    <xsl:template name="node">
        <xsl:for-each select="//node">
        <xsl:copy>
            <xsl:copy-of select="@*"/>
            <xsl:call-template name="volist"/>
            <xsl:copy-of select="*[not(name()='volist')]"/>
        </xsl:copy>
        </xsl:for-each>
    </xsl:template>
    
    <xsl:template name="volist">
        <xsl:choose>
            <xsl:when test="not(count(volist)=0)">
                <xsl:variable name="excludes" select="volist/exclude"/>
                <xsl:variable name="includes" select="volist/include"/>
                <xsl:for-each select="//vo">
                    <xsl:if test="count($excludes[@name=current()/@name])=0 and
                        (count($includes)=0 or count($includes[@name=current()/@name])=1)">
                        <xsl:element name="volist">
                            <xsl:copy-of select="@* | *"/>
                        </xsl:element>
                    </xsl:if>
                </xsl:for-each>
            </xsl:when>
            <xsl:otherwise>
                <xsl:for-each select="//vo">
                    <xsl:element name="volist">
                        <xsl:copy-of select="@* | *"/>
                    </xsl:element>
                </xsl:for-each>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>
