#!/usr/bin/env python
#####################################################################################
#
# Copyright (c) Members of the EGEE Collaboration. 2004.
# See http://eu-egee.org/partners/ for details on the copyright holders.
# For license conditions see the license file or http://eu-egee.org/license.html
#
#####################################################################################
#
# General watchdog process
# Authors: Robert Harakaly <robert.harakaly@cern.ch>
#
# $Id: watchdog.py,v 1.2.2.1 2005/08/26 23:39:32 harakaly Exp $
#####################################################################################
import os, time, sys
from xml.dom.minidom import Node
from xml.dom.minidom import parse

global rootNode

def getCommand(name):
    node = rootNode.getElementsByTagName(name)
    return node[0].attributes['value'].nodeValue


verbose = 'false'
timeString = '%Y-%m-%d %H:%M:%S'

if not os.path.exists("/opt/glite/etc/watchdog.d"):
        sys.exit(0)

filelist = os.listdir("/opt/glite/etc/watchdog.d/" )
for process in filelist:
    dom = parse("/opt/glite/etc/watchdog.d/%s" %process)
    rootNode = dom.childNodes[0]
    node = rootNode.getElementsByTagName('command')

    com = os.popen("(. /etc/glite/profile.d/glite_setenv.sh ; %s 2>&1)" % getCommand("command"))
    out = com.read().strip()
    com.close()

    if out != getCommand('result-string'):
        print("[%s] Executed command: %s" % (time.strftime(timeString,time.gmtime()), getCommand("command")))
        print("[%s] Got result: %s" % (time.strftime(timeString,time.gmtime()), out))
        print("[%s] Expected result: %s" % (time.strftime(timeString,time.gmtime()), getCommand('result-string')))
        print("[%s] Restarting service: %s" % (time.strftime(timeString,time.gmtime()), process[0:process.rfind(".")]))
        print("\n                         #####################################")
        stop = os.popen(getCommand("stop-command"))
        for line in stop:
            print("                         %s" % line.strip())
        start = os.popen(getCommand('start-command'))
        for line in start:
            print("                         %s" % line.strip())
        print("                         #####################################")
        print("\n\n")
